
# Define selectors
  # HadGEM3 daily data (360_day)
  path_hadgem3 <- paste0('/esarchive/exp/CMIP6/dcppA-hindcast/hadgem3-gc31-mm/',
                         'cmip6-dcppA-hindcast_i1p1/DCPP/MOHC/HadGEM3-GC31-MM/',
                         'dcppA-hindcast/r1i1p1f2/day/$var$/gn/v20200101/',
                         '$var$_day_HadGEM3-GC31-MM_dcppA-hindcast_s$sdate$-r1i1p1f2_gn_$fyear$.nc')
  ## tasmax_day_HadGEM3-GC31-MM_dcppA-hindcast_s2000-r1i1p1f2_gn_20001101-20101230.nc

  # MPI-ESM1.2-HR (standard)
  path_mpi_esm <- paste0('/esarchive/exp/CMIP6/dcppA-hindcast/mpi-esm1-2-hr/',
                         'cmip6-dcppA-hindcast_i1p1/DCPP/MPI-M/MPI-ESM1-2-HR/',
                         'dcppA-hindcast/r1i1p1f1/day/$var$/gn/v20200101/',
                         '$var$_day_MPI-ESM1-2-HR_dcppA-hindcast_s$sdate$-r1i1p1f1_gn_$fyear$.nc')
  ## tasmax_day_MPI-ESM1-2-HR_dcppA-hindcast_s2000-r1i1p1f1_gn_20001101-20101231.nc

  # Selectors
  sdate <- '2000'
  fyear_hadgem3 <- paste0(sdate, '1101-', as.numeric(sdate) + 10, '1230')
  fyear_mpi_esm <- paste0(sdate, '1101-', as.numeric(sdate) + 10, '1231')
  time_hadgem3 <- indices(c(60, NA, 61)) #12/30, NA, 1/1
  time_mpi_esm <- indices(60:62) #12/30, 12/31, 1/1


res <- multi_Start(
         dat = list(list(name = 'hadgem3', path = path_hadgem3),
                    list(name = 'mpi_esm', path = path_mpi_esm)),
         var = 'tasmax', sdate = '2000',
         fyear = list(list(name = 'hadgem3', fyear = fyear_hadgem3),
                      list(name = 'mpi_esm', fyear = fyear_mpi_esm)),
         time = list(list(name = 'hadgem3', time = time_hadgem3),
                     list(name = 'mpi_esm', time = time_mpi_esm)),
         lat = indices(1), lon = indices(1),
         #fyear_depends = 'sdate',
         return_vars = list(lat = 'dat', lon = 'dat', time = 'sdate'),
         retrieve = TRUE)


#----------------merge_across_dim-----------------
path <-'/esarchive/recon/ecmwf/erainterim/monthly_mean/$var$_f6h/$var$_$sdate$.nc'
sdate <- c('199801', '199802', '199803')
time <- indices(c(1, 2, 3, NA))
res <- multi_Start(
         dat = list(list(name = 'erainterim', path = path)),
         var = 'tas', 
         sdate = sdate,
         time = list(list(name = 'erainterim', time = time)),
         time_across = 'sdate',
         merge_across_dims = TRUE,
         lat = indices(1), lon = indices(1),
         return_vars = list(lat = 'dat', lon = 'dat', time = 'sdate'),
         retrieve = TRUE)






#----------------------------------------
# Start() separately
res1 <- Start(
         dat = list(list(name = 'hadgem3', path = path_hadgem3)),
         var = 'tasmax', sdate = '2000',
         fyear = fyear_hadgem3,
         time = indices(c(60, 61)),
         lat = indices(1), lon = indices(1),
         return_vars = list(lat = 'dat', lon = 'dat', time = 'sdate'),
         retrieve = TRUE)

res2 <- Start(
         dat = list(list(name = 'mpi_esm', path = path_mpi_esm)),
         var = 'tasmax', sdate = '2000',
         fyear = fyear_mpi_esm,
         time = time_mpi_esm,
         lat = indices(1), lon = indices(1),
         return_vars = list(lat = 'dat', lon = 'dat', time = 'sdate'),
         retrieve = TRUE)


str(res)
attr(res, 'Variables')$hadgem3$time
[1] "2000-12-29 12:00:00 UTC" "2000-12-30 12:00:00 UTC"
[3] "2001-01-01 12:00:00 UTC" "2001-01-02 12:00:00 UTC"
res_list$test_mpi_esm
[1] "2000-12-29 12:00:00 UTC" "2000-12-30 12:00:00 UTC"
[3] "2000-12-31 12:00:00 UTC" "2001-01-01 12:00:00 UTC"

